
From: "Antonino A. Daplas" <adaplas@hotpop.com>

Changes in neo_map_mmio to make neofb working on NM2070, NM2090, NM2093.

From: Marek Marczykowski <marmarek@staszic.waw.pl>
Signed-off-by: Marek Marczykowski <marmarek@staszic.waw.pl>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/drivers/video/neofb.c |   22 +++++++++++++++++++++-
 1 files changed, 21 insertions(+), 1 deletion(-)

diff -puN drivers/video/neofb.c~neofb-mmio-fixes drivers/video/neofb.c
--- 25/drivers/video/neofb.c~neofb-mmio-fixes	2005-03-20 16:05:04.000000000 -0800
+++ 25-akpm/drivers/video/neofb.c	2005-03-20 16:05:04.000000000 -0800
@@ -1691,7 +1691,27 @@ static int __devinit neo_map_mmio(struct
 
 	DBG("neo_map_mmio");
 
-	info->fix.mmio_start = pci_resource_start(dev, 1);
+	switch (info->fix.accel) {
+		case FB_ACCEL_NEOMAGIC_NM2070:
+			info->fix.mmio_start = pci_resource_start(dev, 0)+
+				0x100000;
+			break;
+		case FB_ACCEL_NEOMAGIC_NM2090:
+		case FB_ACCEL_NEOMAGIC_NM2093:
+			info->fix.mmio_start = pci_resource_start(dev, 0)+
+				0x200000;
+			break;
+		case FB_ACCEL_NEOMAGIC_NM2160:
+		case FB_ACCEL_NEOMAGIC_NM2097:
+		case FB_ACCEL_NEOMAGIC_NM2200:
+		case FB_ACCEL_NEOMAGIC_NM2230:
+		case FB_ACCEL_NEOMAGIC_NM2360:
+		case FB_ACCEL_NEOMAGIC_NM2380:
+			info->fix.mmio_start = pci_resource_start(dev, 1);
+			break;
+		default:
+			info->fix.mmio_start = pci_resource_start(dev, 0);
+	}
 	info->fix.mmio_len = MMIO_SIZE;
 
 	if (!request_mem_region
_
